package no.tornado.query;

public class JoinTable {
    public enum JOIN_TYPE { JOIN, LEFT_JOIN };
    
    private String name;
    private String alias;
    private JOIN_TYPE joinType;
    private String on;
    public transient String pkColumn;

    public JoinTable(String name) {
        this(name, name, JOIN_TYPE.JOIN);
    }

    public JoinTable(String name, String alias) {
        this(name, alias, JOIN_TYPE.JOIN);
    }
    
    public JoinTable(String name, String alias, JOIN_TYPE joinType) {
        this.name = name;
        this.alias = alias;
        this.joinType = joinType;
    }

    public String toString() {
        return joinType + " " + name + " AS " + alias;
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        JoinTable joinTable = (JoinTable) o;

        if (!alias.equals(joinTable.alias)) return false;
        if (joinType != joinTable.joinType) return false;
        if (!name.equals(joinTable.name)) return false;

        return true;
    }

    public int hashCode() {
        int result = name.hashCode();
        result = 31 * result + alias.hashCode();
        result = 31 * result + joinType.hashCode();
        return result;
    }

    public JOIN_TYPE getJoinType() {
        return joinType;
    }

    public JoinTable joinType(JOIN_TYPE joinType) {
        this.joinType = joinType;
        return this;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getAlias() {
        return alias;
    }

    public void setAlias(String alias) {
        this.alias = alias;
    }

    public String getOn() {
        return on;
    }

    public void setOn(String on) {
        this.on = on;
    }

    public JoinTable on(String on) {
        this.on = on;
        return this;
    }


}
