package no.tornado.query;

public class ResultMapping {
    private String column;
    private ResultMap.MapType mapType;
    private JoinTable joinTable;
    private String property;
    private String sequence;

    public ResultMapping(String property, String column) {
        this.property = property;
        this.column = column;
        this.mapType = ResultMap.MapType.TABLE_COLUMN;
    }

    public ResultMapping(String property, String column, ResultMap.MapType mapType) {
        this.property = property;
        this.column = column;
        this.mapType = mapType;
    }

    public String getQualifiedColumn() {
        if (joinTable != null)
            return joinTable.getAlias() + "_" + column;

        return column;
    }

    public String toString() {
        StringBuilder s = new StringBuilder(property + " -> " + getQualifiedColumn() + " " + mapType);
        if (joinTable != null)
            s.append(" (" + joinTable.getAlias() + ")");

        if (sequence != null)
            s.append(", sequence " + sequence);

        return s.toString();
    }
    
    public String getColumn() {
        return column;
    }

    public void setColumn(String column) {
        this.column = column;
    }

    public String getProperty() {
        return property;
    }

    public void setProperty(String property) {
        this.property = property;
    }

    public ResultMap.MapType getMapType() {
        return mapType;
    }

    public void setMapType(ResultMap.MapType mapType) {
        this.mapType = mapType;
    }

    public JoinTable getJoinTable() {
        return joinTable;
    }

    public void setJoinTable(JoinTable joinTable) {
        this.joinTable = joinTable;
    }

    public ResultMapping joinTable(JoinTable joinTable) {
        this.joinTable = joinTable;
        return this;
    }

    public String getSequence() {
        return sequence;
    }

    public void setSequence(String sequence) {
        this.sequence = sequence;
    }
}
