package no.tornado.query.typehandler;

import java.sql.Timestamp;
import java.sql.Types;
import java.util.Date;

public class DateToTimestampHandler implements TypeHandler {
    public Class javaClass() {
        return Date.class;
    }

    public Class sqlClass() {
        return Timestamp.class;
    }

    public int sqlType() {
        return Types.TIMESTAMP;
    }

    public Object convertParameter(Object javaObject) {
        Date date = (Date) javaObject;
        return new Timestamp(date.getTime());
    }

    public Object convertResult(Object resultObject) {
        Timestamp ts = (Timestamp) resultObject;
        return new Date(ts.getTime());
    }

}
